unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VCLTee.TeEngine, Vcl.ExtCtrls,
  VCLTee.TeeProcs, VCLTee.Chart, VCLTee.TeeFunci, VCLTee.Series,
  VCLTee.OHLChart, VCLTee.CandleCh, Vcl.StdCtrls, Vcl.ComCtrls;

type
  TIABRealTimeData=record
    DateTime: TDateTime;
    Open: Double;
    High: Double;
    Low: Double;
    Close: Double;
  end;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TCandleSeries;
    Series2: TFastLineSeries;
    TeeFunction1: THighTeeFunction;
    Panel1: TPanel;
    BAddAndShowIndices: TButton;
    EPeriod: TEdit;
    UDPeriod: TUpDown;
    LPeriod: TLabel;
    procedure BAddAndShowIndicesClick(Sender: TObject);
    procedure EPeriodChange(Sender: TObject);
  private
    { Private declarations }
    procedure GoToTeechart(Sender: TObject; DataId: Integer; RealTimeDataElement: TIABRealTimeData);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.BAddAndShowIndicesClick(Sender: TObject);
var tmp: TIABRealTimeData;
begin
  tmp.DateTime:=Series1.XValues.Last+1;
  tmp.Open:=Series1.OpenValues.Last+1;
  tmp.High:=Series1.HighValues.Last+1;
  tmp.Low:=Series1.LowValues.Last+1;
  tmp.Close:=Series1.CloseValues.Last+1;

  GoToTeechart(Self, Series1.Count, tmp);
end;


procedure TForm1.EPeriodChange(Sender: TObject);
begin
  TeeFunction1.Period:=UDPeriod.Position;
end;

procedure TForm1.GoToTeechart(Sender: TObject; DataId: Integer; RealTimeDataElement: TIABRealTimeData);
var
  Open,High,Low,Close: Double;
  first1,last1,first2,last2:integer;
  tid:tdatetime;
begin
  tid:=realtimedataelement.DateTime;
  Open:=RealTimeDataElement.Open;
  High:=RealTimeDataElement.High;
  Low:=RealTimeDataElement.Low;
  Close:=RealTimeDataElement.Close;

  Chart1.LeftAxis.Maximum :=high+1 ;
  Chart1.LeftAxis.minimum :=low-1 ;

  //series1.AddCandle(now,open,high,low,close);
  series1.AddCandle(tid,open,high,low,close);
  Series2.CheckDataSource;

  chart1.Axes.Bottom.AdjustMaxMin;
  self.series1.CalcFirstLastVisibleIndex;

  self.Series2.CalcFirstLastVisibleIndex;

  first1:=series1.FirstDisplayedIndex;
  last1:=series1.LastDisplayedIndex;

  first2:=series2.FirstDisplayedIndex;
  last2:=series2.LastDisplayedIndex;

  //first2:=chart1.Series[1].FirstDisplayedIndex;
  //last2:=chart1.Series[1].LastDisplayedIndex;

  //codesite.Send(format('first1:%d  first2:%d  last1:%d  last2:%d',[first1,first2,last1,last2]));
  ShowMessage(format('first1: %d  first2: %d  last1: %d  last2: %d', [first1,first2,last1,last2]));
end;

end.
